﻿namespace TestProject;

/// <summary>
/// 메인 페이지
/// </summary>
public partial class MainPage : ContentPage
{
    //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
    ////////////////////////////////////////////////////////////////////////////////////////// Public

    #region 생성자 - MainPage()

    /// <summary>
    /// 생성자
    /// </summary>
    public MainPage()
    {
        InitializeComponent();

        OrientationSensor.ReadingChanged += orientationSensor_ReadingChanged;
        this.startButton.Clicked         += startButton_Clicked;
    }

    #endregion

    //////////////////////////////////////////////////////////////////////////////////////////////////// Method
    ////////////////////////////////////////////////////////////////////////////////////////// Private

    #region 방향 센서 읽기 변경시 처리하기 - orientationSensor_ReadingChanged(sender, e)

    /// <summary>
    /// 방향 센서 읽기 변경시 처리하기
    /// </summary>
    /// <param name="sender">이벤트 발생자</param>
    /// <param name="e">이벤트 인자</param>
    private void orientationSensor_ReadingChanged(object sender, OrientationSensorChangedEventArgs e)
    {
        OrientationSensorData data = e.Reading;

        this.label.Text = $"X : {data.Orientation.X}\nY : {data.Orientation.Y}\nZ : {data.Orientation.Z}\nW : {data.Orientation.W}";
    }

    #endregion
    #region 시작 버튼 클릭시 처리하기 - startButton_Clicked(sender, e)

    /// <summary>
    /// 시작 버튼 클릭시 처리하기
    /// </summary>
    /// <param name="sender">이벤트 발생자</param>
    /// <param name="e">이벤트 인자</param>
    private void startButton_Clicked(object sender, EventArgs e)
    {
        if(OrientationSensor.IsMonitoring)
        {
            OrientationSensor.Stop();

            this.startButton.Text = "시작";

            this.label.Text = string.Empty;
        }
        else
        {
            this.startButton.Text = "중단";

            OrientationSensor.Start(SensorSpeed.UI);
        }
    }

    #endregion
}